<template>
  <div>
    <!-- {{ path }} -->
    <!-- {{ config }} -->
    <select :id="path.join('.')" v-model="fieldData" @change="$emit('change', fieldData)">
      <option :value="null" :disabled="true">{{ defaultLabel }}</option>
      <option v-for="option in config.ref" :key="option.id" :value="option.id">
        {{ option.label }}
      </option>
    </select>
  </div>
</template>

<script>
// import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    config: {
      type: Object,
      required: true
    },
    defaultLabel: {
      type: String,
      required: false,
      default: '---'
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField'
      // getFieldConfig: 'Y3TI/getFieldConfig'
    }),
    // config () {
    //   return this.getFieldConfig({ node: this.node, path: this.path })
    // },

    fieldData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        return this.getEditedField({ node: this.node, path: this.path })
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
      }
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...[this.config.path] ]
    // }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
  }
}
</script>

<style lang="scss" scoped>
</style>
